<script>

	import { onMount, onDestroy, beforeUpdate, afterUpdate, createEventDispatcher } from 'svelte';

	const dispatch = createEventDispatcher();
	
	const GRID_SIZE = 100;

	export let raw   = false;
  export let x     = 0;
	export let y     = 0;
	export let state = -1;
	
	let classes = [];

	function onMouseOver(e) {
		dispatch('hover', {x, y});
	}

	function onMouseOut(e) {
		dispatch('blur', {x, y});
	}

	beforeUpdate(() => {

		const _classes = [];

		if(raw)
			_classes.push('raw');

		if(state === 1)
			_classes.push('state-valid');
		else if(state === 0)
			_classes.push('state-invalid');

		classes = _classes;
	});

</script>

<style>

	.cell {
		width : 99px;
		height: 99px;
		border: 1px solid rgba(255, 255, 255, 0.1);
		background-color: rgba(0, 0, 0, 0.1);
		position: absolute;
	}

	.cell.raw {
		width: 100%;
		height: 100%;
	}

	.cell.state-valid {
		background-color: rgba(0, 255, 0, 0.1);
	}

	.cell.state-invalid {
		background-color: rgba(255, 0, 0, 0.1);
	}
	
</style>

<div
  class="cell {classes.join(' ')}"
  style="left: {x * GRID_SIZE}px; top: {y * GRID_SIZE}px;"
	on:mouseover={onMouseOver}
	on:mouseOut={onMouseOut}
></div>